# importy se píší na začátek, aby člověk nemusel prohledávat celý program, jaké další knihovny se používají...
import turtle

#
# A) výpočet předpisu pro třetí generaci Kochova ostrova
#

stará_generace = 'A'    # řetězec o délce 1 (= jeden znak/prvek)
print('0')
print(stará_generace)

for i in range(1, 4):
    print(i)
    nová_generace = ''  # prázdný řetězec
    # výpočet nové generace
    for znak in stará_generace:
        match znak:
            case 'A':
                nová_generace += 'F[+A]-A'
            case 'F':
                nová_generace += 'FF'
            case _:     # ostatní znaky zkopírujeme tak jak jsou
                nová_generace += znak
    # vypíšeme kompletní podobu nové generace
    print(nová_generace)
    # nová generace se stane starou a z ní vypočítáme ještě novější generaci
    stará_generace = nová_generace

#
# B) vykreslení třetí generace Kochova ostrova
#

turtle.speed(0)
turtle.teleport(-200, 200)

předpis = stará_generace

# zaveďmež si užitečné "konstanty" -- jiný zápis pomocí tzv. n-tic (vlevo od '=' dvojce, vpravo od '=' také dvojce)
# PS: Python pojem 'konstanta' nezná, ale při pojmenování pomocí samých velkých písmen všichni předstírají, že to konstanty jsou...
KROK, ÚHEL = 10, 45

turtle.title('Strom (3. generace)')
turtle.bgcolor('lightblue')
turtle.pensize(2)

zásobník_stavů_želvy = []   # list()

for znak in předpis:
    match znak:
        case 'F' | 'A':
            turtle.forward(KROK)
        case '-':
            turtle.right(ÚHEL)
        case '+':
            turtle.left(ÚHEL)
        case '[':
            zásobník_stavů_želvy.append(
                (turtle.position(), turtle.heading())   # dvojce (= jeden prvek)
            )
            print('[', zásobník_stavů_želvy)
        case ']':
            poslední_stav_želvy = zásobník_stavů_želvy.pop(-1)
            pozice, úhel = poslední_stav_želvy
            print('\t', pozice, úhel)
            print(']', zásobník_stavů_želvy)

turtle.mainloop()
